/*****************************************************************************\
 *                                                                           *
 * TestCompiled.cpp                                                          *
 *                                                                           *
 * ------------------------------------------------------------------------- *
 * Copyright (C) 2007 Bryan Ischo <bryan@ischo.com>                          *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License Version 2 as published  *
 * by the Free Software Foundation.                                          *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License         *
 * along with this program; if not, write to:                                *
 * The Free Software Foundation, Inc.                                        *
 * 51 Franklin Street, Fifth Floor                                           *
 * Boston, MA 02110-1301, USA.                                               *
 * ------------------------------------------------------------------------- *
 *                                                                           *
 * See TestCompiled.h                                                        *
 *                                                                           *
\*****************************************************************************/

#include <Essential/File.h>
#include <Xrtti/Xrtti.h>
#include "test/TestCoverage.h"
#include "test/XrttiToCpp.h"

using namespace Essential;
using namespace Xrtti;

/** **************************************************************************
 * Method definitions
 ************************************************************************** **/

AnonymousStructs::HasAName::HasAName(const HasAName &_ctor_arg)
{
}

AnonymousStructs::HasAName::HasAName()
{
}

AnonymousStructs::HasANameToo::HasANameToo(const HasANameToo &_ctor_arg)
{
}

AnonymousStructs::HasANameToo::HasANameToo()
{
}

AnonymousStructs::AnonymousStructs(const AnonymousStructs &_ctor_arg)
{
}

AnonymousStructs::AnonymousStructs()
{
}

int BasicTypes::field_u;

BasicTypes::BasicTypes(const BasicTypes &_ctor_arg)
    : field_a((void *) 0), field_c('1'), field_f(2), field_i(3), field_m(4),
      field_r(5.0), field_t(6)
{
}

BasicTypes::BasicTypes(int a)
    : field_a((void *) 0), field_c('1'), field_f(2), field_i(3), field_m(4),
      field_r(5.0), field_t(6)
{
    field_j = a;
}

BasicTypes::BasicTypes(float f, const char *pc)
    : field_a((void *) 0), field_c('1'), field_f(2), field_i(3), field_m(4),
      field_p(f), field_r(5.0), field_t(6)
{
}

BasicTypes::~BasicTypes()
{
}

SimpleClass::SimpleClass(const SimpleClass &_ctor_arg)
{
}

SimpleClass::SimpleClass()
{
}

SimpleClass::~SimpleClass()
{
}

int SimpleClass::method_a(int arg_a, int arg_b) const
{
    return arg_a + arg_b;
}

int SimpleClass::method_b(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

int SimpleClass::method_c(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

int SimpleClass::method_d(int arg_a, int arg_b) const
{
    return arg_a + arg_b;
}

int SimpleClass::method_e(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

int SimpleClass::method_f(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

const char *SimpleClass::method_g()
{
    return "a";
}

DerivedClass::~DerivedClass()
{
}

int DerivedClass::method_a(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

int DerivedClass::method_b(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

int DerivedClass::method_g(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

int DerivedClass::method_h(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

DerivedClass::DerivedClass(const DerivedClass &_ctor_arg)
{
}

DerivedClass::DerivedClass()
{
}

FirstNamespace::AbstractClass::AbstractClass(const AbstractClass &_ctor_arg)
{
}

FirstNamespace::AbstractClass::AbstractClass()
{
}

FirstNamespace::AbstractClass::~AbstractClass()
{
}

FirstNamespace::SecondNamespace::ClassDefiner::
ClassDefiner(const ClassDefiner &_ctor_arg)
{
}

FirstNamespace::SecondNamespace::ClassDefiner::ClassDefiner()
{
}

FirstNamespace::SecondNamespace::ClassDefiner::Defined::
Defined(const Defined &_ctor_arg)
{
}

FirstNamespace::SecondNamespace::ClassDefiner::Defined::Defined()
{
}

SecondBaseClass::SecondBaseClass(const SecondBaseClass &_ctor_arg)
{
}

SecondBaseClass::SecondBaseClass()
{
}

SecondBaseClass::~SecondBaseClass()
{
}

int SecondBaseClass::method_b(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

SecondMultiDerivedClass::
SecondMultiDerivedClass(const SecondMultiDerivedClass &_ctor_arg)
{
}

SecondMultiDerivedClass::SecondMultiDerivedClass()
{
}

SecondMultiDerivedClass::~SecondMultiDerivedClass()
{
}

int SecondMultiDerivedClass::method_a(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

int SecondMultiDerivedClass::method_b(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

int SecondMultiDerivedClass::method_g(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

int SecondMultiDerivedClass::method_h(int arg_a, int arg_b)
{
    return arg_a + arg_b;
}

UnionDefiner::UnionDefiner(const UnionDefiner &_ctor_arg)
{
}

UnionDefiner::UnionDefiner()
{
}

int main(int argc, char **argv)
{
    XrttiToCpp(File::Stdout);

    return 0;
}
