/*****************************************************************************\
 *                                                                           *
 * GeneratorObject.cpp                                                       *
 *                                                                           *
 * ------------------------------------------------------------------------- *
 * Copyright (C) 2007 Bryan Ischo <bryan@ischo.com>                          *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License Version 2 as published  *
 * by the Free Software Foundation.                                          *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License         *
 * along with this program; if not, write to:                                *
 * The Free Software Foundation, Inc.                                        *
 * 51 Franklin Street, Fifth Floor                                           *
 * Boston, MA 02110-1301, USA.                                               *
 * ------------------------------------------------------------------------- *
 *                                                                           *
\*****************************************************************************/


#include "private/Generator.h"

using namespace Essential;

namespace Xrtti {

#if 0 // This fixes indentation in emacs
}
#endif


void GeneratorObject::EmitDeclaration(OutputStream &out)
{
    out.WriteFA("    static %s _%lu;\n", this->GetCompiledTypeName(),
                numberM);

    this->EmitExtraDeclarations(out);
}


void GeneratorObject::EmitDefinition(OutputStream &out)
{
    // Emit the extra definitions first since this includes the arrays
    // which must be declared before they are used
    this->EmitExtraDefinitions(out);

    out.WriteFA("    %s _::_%lu\n    (\n", this->GetCompiledTypeName(),
                numberM);

    this->EmitDefinitionArguments(out);

    out.WriteA("\n    );\n\n");
}


}; // namespace Xrtti
